DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Private Member Functions | List of all members
DiHSVPixelTemplate< T1, T2 > Class Template Reference

Template class to handle HSV pixel data. More...

Inheritance diagram for DiHSVPixelTemplate< T1, T2 >:

## Public Member Functions
| DiHSVPixelTemplate (const DiDocument *docu, const DiInputPixel *pixel, EI_Status &status, const unsigned long planeSize, const int bits)
| constructor More...
virtual | ~DiHSVPixelTemplate ()
| destructor
Public Member Functions inherited from DiColorPixelTemplate< T2 >
| DiColorPixelTemplate (const DiDocument *docu, const DiInputPixel *pixel, const Uint16 samples, EI_Status &status, const Uint16 sample_rate=0)
| constructor More...
virtual | ~DiColorPixelTemplate ()
| destructor
EP_Representation | getRepresentation () const
| get integer representation More...
const void * | getData () const
| get pointer to internal array of pixel data. More...
void * | getDataPtr ()
| get pointer to internal array of pixel data. More...
void * | getDataArrayPtr ()
| get pointer to internal array of pixel data. More...
OFBool | getPixelData (void *data, const unsigned long count, const unsigned long fcount, const unsigned long frames, const int planar) const
| fill given memory block with pixel data (all three image planes, RGB) More...
unsigned long | createDIB (void *&data, const unsigned long size, const Uint16 width, const Uint16 height, const unsigned long frame, const int fromBits, const int toBits, const int mode, const int upsideDown, const int padding) const
| create true color (24/32 bit) bitmap for MS Windows. More...
unsigned long | createAWTBitmap (void *&data, const Uint16 width, const Uint16 height, const unsigned long frame, const int fromBits, const int toBits) const
| create true color (32 bit) bitmap for Java (AWT default format). More...
Public Member Functions inherited from DiColorPixel
| DiColorPixel (const DiDocument *docu, const DiInputPixel *pixel, const Uint16 samples, EI_Status &status, const Uint16 sample_rate=0)
| constructor More...
virtual | ~DiColorPixel ()
| destructor
int | getPlanes () const
| get number of planes More...
int | getPlanarConfiguration () const
| get planar configuration of the original pixel data More...
Public Member Functions inherited from DiPixel
| DiPixel (const unsigned long count, const unsigned long inputCount=0)
| constructor More...
virtual | ~DiPixel ()
| destructor
unsigned long | getCount () const
| get number of pixels More...
unsigned long | getInputCount () const
| get number of pixels stored in the 'PixelData' element More...
Public Member Functions inherited from DiPixelRepresentationTemplate< T2 >
| DiPixelRepresentationTemplate ()
| default constructor
virtual | ~DiPixelRepresentationTemplate ()
| destructor
int | isSigned () const
| check whether template type T is signed or not More...

## Private Member Functions
void | convert (const T1 *pixel, const unsigned long planeSize, const int bits)
| convert input pixel data to intermediate representation More...
void | convertValue (T2 &red, T2 &green, T2 &blue, const T2 hue, const T2 saturation, const T2 value, const T2 maxvalue)
| convert a single HSV value to RGB More...

## Additional Inherited Members
Protected Member Functions inherited from DiColorPixelTemplate< T2 >
| DiColorPixelTemplate (const DiColorPixel *pixel, const unsigned long count)
| constructor More...
int | Init (const void *pixel)
| initialize internal memory More...
Protected Member Functions inherited from DiColorPixel
| DiColorPixel (const DiColorPixel *pixel, const unsigned long count)
| constructor More...
Protected Attributes inherited from DiColorPixelTemplate< T2 >
T2 * | Data [3]
| pointer to pixel data (3 components)
Protected Attributes inherited from DiColorPixel
int | PlanarConfiguration
| planar configuration of the original pixel data (0 = color-by-pixel, 1 = color-by-plane)
Protected Attributes inherited from DiPixel
unsigned long | Count
| number of pixels
unsigned long | InputCount
| number of pixels in the input buffer

## Detailed Description

### template<class T1, class T2>
class DiHSVPixelTemplate< T1, T2 >

Template class to handle HSV pixel data.

## Constructor & Destructor Documentation

## ◆ DiHSVPixelTemplate()

template<class T1 , class T2 >

DiHSVPixelTemplate< T1, T2 >::DiHSVPixelTemplate | ( | const DiDocument * | docu,
|  | const DiInputPixel * | pixel,
|  | EI_Status & | status,
|  | const unsigned long | planeSize,
|  | const int | bits
| ) |  |
| inline

constructor

Parameters

  docu | pointer to DICOM document
  pixel | pointer to input pixel representation
  status | reference to status variable
  planeSize | number of pixels in a plane
  bits | number of bits per sample

References DiHSVPixelTemplate< T1, T2 >::convert(), DiPixel::Count, and EIS_Normal.

## Member Function Documentation

## ◆ convert()

template<class T1 , class T2 >

void DiHSVPixelTemplate< T1, T2 >::convert | ( | const T1 * | pixel,
|  | const unsigned long | planeSize,
|  | const int | bits
| ) |  |
| inline private

convert input pixel data to intermediate representation

Parameters

  pixel | pointer to input pixel data
  planeSize | number of pixels in a plane
  bits | number of bits per sample

References DiColorPixelTemplate< T2 >::Data, and DiColorPixelTemplate< T2 >::Init().

Referenced by DiHSVPixelTemplate< T1, T2 >::DiHSVPixelTemplate().

## ◆ convertValue()

template<class T1 , class T2 >

void DiHSVPixelTemplate< T1, T2 >::convertValue | ( | T2 & | red,
|  | T2 & | green,
|  | T2 & | blue,
|  | const T2 | hue,
|  | const T2 | saturation,
|  | const T2 | value,
|  | const T2 | maxvalue
| ) |  |
| inline private

convert a single HSV value to RGB

Parameters

  red | the red part of the RGB value
  green | the green part of the RGB value
  blue | the blue part of the RGB value
  hue | the hue part of the HSV value
  saturation | the saturation part of the HSV value
  value | the value part of the HSV value
  the | maximal value of any rgb value

The documentation for this class was generated from the following file:

- dcmimage/include/dcmtk/dcmimage/dihsvpxt.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1